//v0.2: changed pins for RGBLED
#include "Arduino.h"
#include "CARL.h"

CARL::CARL(int rSpeed)
{
	#define MPIN1B 5 // motor 1 pin B
	#define MPIN1A 6 // motor 1 pin A
	#define MPIN2A 9 // motor 2 pin A
	#define MPIN2B 10 // motor 2 pin B
	
	_rSpeed = rSpeed;
	
	Serial.begin(115200); // serial for serial port
	
	pinMode(MPIN1B,OUTPUT); // set motor pin as output
	pinMode(MPIN1A,OUTPUT); // set motor pin as output
	pinMode(MPIN2A,OUTPUT); // set motor pin as output
	pinMode(MPIN2B,OUTPUT); // set motor pin as output
	
	#define REDPIN A0 // for your lights
	#define GREENPIN A1
	#define BLUEPIN A2
	//
	pinMode(REDPIN,OUTPUT);//
	pinMode(GREENPIN,OUTPUT);
	pinMode(BLUEPIN,OUTPUT);
	//
	//Stop(2000);
}


void CARL::Forward(int delayms){
RGBled(REDPIN,GREENPIN, BLUEPIN,0, 1, 0); //GREEN
Move(-75,-75);
delay(delayms);
Move(0,0);
}

void CARL::Stop(int delayms){
RGBled(REDPIN,GREENPIN, BLUEPIN,1, 0, 0); //RED
Move(0,0);
delay(delayms);
}

void CARL::Reverse(int delayms){
RGBled(REDPIN,GREENPIN, BLUEPIN,0, 0, 1); //BLUE
Move(75,75);
delay(delayms);
Move(0,0);
}
void CARL::TurnRight(int delayms){
RGBled(REDPIN,GREENPIN, BLUEPIN,1, 1, 0); //YELLOW
Move(-75,75);
delay(delayms);
Move(0,0);
}
void CARL::TurnLeft(int delayms){
RGBled(REDPIN,GREENPIN, BLUEPIN,0, 1, 1); //CYAN
Move(75,-75);
delay(delayms);
Move(0,0);
}
void CARL::RGBled(int redPin, int greenPin, int bluePin, int redValue, int greenValue, int blueValue){
pinMode(redPin,OUTPUT);//
pinMode(greenPin,OUTPUT);
pinMode(bluePin,OUTPUT);
digitalWrite(redPin, redValue);//
digitalWrite(greenPin, greenValue);
digitalWrite(bluePin, blueValue);
}
void CARL::RGBled2(int color){
//pinMode(redPin,OUTPUT);//
//pinMode(greenPin,OUTPUT);
//pinMode(bluePin,OUTPUT);
switch (color) {
	case 0://NONE
	digitalWrite(REDPIN, 0);
	digitalWrite(GREENPIN, 0);
	digitalWrite(BLUEPIN, 0);
	break;
	case 1://RED
	digitalWrite(REDPIN, 1);
	digitalWrite(GREENPIN, 0);
	digitalWrite(BLUEPIN, 0);
	break;
	case 2://BLUE
	digitalWrite(REDPIN, 0);
	digitalWrite(GREENPIN, 0);
	digitalWrite(BLUEPIN, 1);
	break;
	case 3://GREEN
	digitalWrite(REDPIN, 0);
	digitalWrite(GREENPIN, 1);
	digitalWrite(BLUEPIN, 0);
	break;
	case 4://CYAN
	digitalWrite(REDPIN, 0);
	digitalWrite(GREENPIN, 1);
	digitalWrite(BLUEPIN, 1);
	break;
	case 5://MAGENTA
	digitalWrite(REDPIN, 1);
	digitalWrite(GREENPIN, 0);
	digitalWrite(BLUEPIN, 1);
	break;
	case 6://YELLOW
	digitalWrite(REDPIN, 1);
	digitalWrite(GREENPIN, 1);
	digitalWrite(BLUEPIN, 0);
	break;
	case 7://WHITE
	digitalWrite(REDPIN, 1);
	digitalWrite(GREENPIN, 1);
	digitalWrite(BLUEPIN, 1);
	break;
}
}

//Private
void CARL::Move(int m1, int m2) {
if (m1 < 0) { // for reverse - not used
analogWrite(MPIN1A, _rSpeed * abs(m1) / 100);
analogWrite(MPIN1B, 0);
}
else
{ // normal operation
analogWrite(MPIN1A, 0);
analogWrite(MPIN1B, _rSpeed * m1 / 100);
}
if (m2 < 0) { // for reverse - not used
analogWrite(MPIN2A, _rSpeed * abs(m2) / 100);
analogWrite(MPIN2B, 0);
}
else
{ // normal operation
analogWrite(MPIN2A, 0);
analogWrite(MPIN2B, _rSpeed * m2 / 100);
}
}
