
//https://www.arduino.cc/en/Hacking/LibraryTutorial
//https://www.alanzucconi.com/2016/05/11/libraries-for-arduino/

// ensure this library description is only included once
#ifndef CARL_h
#define CARL_h

#include "Arduino.h"

// include types & constants of Wiring core API
//#include "WConstants.h"

// library interface description
class CARL
{
  // user-accessible "public" interface
  public:
    CARL(int rSpeed);
    void Forward(int delayms);
	void Reverse(int delayms);
	void TurnRight(int delayms);
	void TurnLeft(int delayms);
	void Stop(int delayms);
	void RGBled2(int color);

  // library-accessible "private" interface
  private:
	void Move(int m1, int m2);
	int _rSpeed;
	void RGBled(int redPin, int greenPin, int bluePin, int redValue, int greenValue, int blueValue);//from private
};

#endif